## clfft 2.4

=== src/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

if( WIN32 )
	# We require 2.8.3 for windows because of a bug in cmake that prevented vs2010 from generating
	# executables properly with multiple periods
	cmake_minimum_required( VERSION 2.8.3 )
else( )
	cmake_minimum_required( VERSION 2.6 )
endif( )

if( CMAKE_GENERATOR MATCHES "NMake" )
	option( NMAKE_COMPILE_VERBOSE "Print compile and link strings to the console" OFF )
	if( NMAKE_COMPILE_VERBOSE )
		set( CMAKE_START_TEMP_FILE "" )
		set( CMAKE_END_TEMP_FILE "" )
		set( CMAKE_VERBOSE_MAKEFILE 1 )
	endif( )
endif( )

# This becomes the name of the solution file
project( clFFT )

# Define a version for the code
if( NOT DEFINED CLFFT_VERSION_MAJOR )
    set( CLFFT_VERSION_MAJOR 2 )
endif( )

if( NOT DEFINED CLFFT_VERSION_MINOR )
    set( CLFFT_VERSION_MINOR 4 )
endif( )

if( NOT DEFINED CLFFT_VERSION_PATCH )
    set( CLFFT_VERSION_PATCH 0 )
endif( )

set( CLFFT_VERSION "${CLFFT_VERSION_MAJOR}.${CLFFT_VERSION_MINOR}.${CLFFT_VERSION_PATCH}")
	
# This is incremented when the ABI to the library changes
set( CLFFT_SOVERSION 2 )

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR} )

# On windows, it's convenient to change the default install prefix such that it does NOT point to 'program files'
# Need to check out CMAKE_RUNTIME_OUTPUT_DIRECTORY variable, and see if that eliminates the need to modify install path
if( CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
	set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories" FORCE )
endif( )

# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.  MSVC_IDE does not use CMAKE_BUILD_TYPE
if( NOT MSVC_IDE AND NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE )
endif()

# Options that the user or driver program can set to control various components of the build
option( BUILD_RUNTIME "Build the FFT runtime library" ON )
option( BUILD_CLIENT "Build a command line clFFT client program with a variety of configurable parameters (dependency on Boost)" ON )
option( BUILD_TEST "Build the library testing suite (dependency on google test, Boost, and FFTW)" ON )
option( BUILD_LOADLIBRARIES "Build the optional dynamic load libraries that the FFT runtime will search for" ON )
option( BUILD_SHARED_LIBRARY "Build shared libraries." ON)

# If BOOST_ROOT is defined as an environment value, use that value and cache it so it's visible in the cmake-gui.
# Otherwise, create a sensible default that the user can change
if( DEFINED ENV{BOOST_ROOT} )
	set( BOOST_ROOT $ENV{BOOST_ROOT} CACHE PATH "Environment variable defining the root of the Boost installation" )
endif( )

# Currently, linux has a problem outputing both narrow and wide characters,
# which happens in our client because openCL only supports narrow characters
if( WIN32 )
	option( UNICODE "Build with Unicode Support" ON )
	if( UNICODE )
		message( STATUS "UNICODE build" )
	endif( )
else()
	set( UNICODE OFF )
	message( STATUS "UNICODE feature disabled on linux" )
endif()

if( MSVC_IDE )
    set_property( GLOBAL PROPERTY USE_FOLDERS TRUE )

	set( BUILD64 ${CMAKE_CL_64} )
else()
	option( BUILD64 "Build a 64-bit product" ON )

	if( IS_DIRECTORY ${PROJECT_SOURCE_DIR}/tests )
		option( CODE_COVERAGE "Build makefiles with code coverage instrumentation" OFF )
		if( CODE_COVERAGE )
			message( STATUS "Code coverage instrumentation on" )
		endif()
	endif()
endif()

# These variables are meant to contain string which should be appended to the installation paths
# of library and executable binaries, respectively.  They are meant to be user configurable/overridable.
set( SUFFIX_LIB_DEFAULT "" )
set( SUFFIX_BIN_DEFAULT "" )

# Modify the global find property to help us find libraries like Boost in the correct paths for 64-bit
# Essentially, find_library calls will look for /lib64 instead of /lib; works for windows and linux
if( BUILD64 )
	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE )
	message( STATUS "64bit build - FIND_LIBRARY_USE_LIB64_PATHS TRUE" )

    set( SUFFIX_LIB_DEFAULT "64" )
else( )
	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE )
	message( STATUS "32bit build - FIND_LIBRARY_USE_LIB64_PATHS FALSE" )
endif( )

set( SUFFIX_LIB ${SUFFIX_LIB_DEFAULT} CACHE STRING "String to append to 'lib' install path" )
set( SUFFIX_BIN ${SUFFIX_BIN_DEFAULT} CACHE STRING "String to append to 'bin' install path" )

# Useful variables to configure FindBoost.cake
# set( Boost_USE_MULTITHREADED ON )
# set( Boost_DETAILED_FAILURE_MSG   ON )
# set( Boost_DEBUG ON )
# set( Boost_NO_SYSTEM_PATHS ON )

# Client is built only if boost is found; on windows, we need vs10 or higher
# Find Boost on the system, and configure the type of boost build we want
if( NOT DEFINED Boost_USE_STATIC_LIBS )
   set( Boost_USE_STATIC_LIBS   ON )
endif( )

if( NOT DEFINED Boost_USE_STATIC_RUNTIME )
   set( Boost_USE_STATIC_RUNTIME OFF )
endif( )

# This will define Boost_FOUND
find_package( Boost 1.33.0 COMPONENTS program_options )
if( Boost_FOUND )
   message( STATUS "Boost_PROGRAM_OPTIONS_LIBRARY: ${Boost_PROGRAM_OPTIONS_LIBRARY}" )
else( )
   message( WARNING "Try setting Boost_DEBUG and Boost_DETAILED_FAILURE_MSG for more information" )
endif( )

# This will define OPENCL_FOUND
find_package( OpenCL )

# This will define FFTW_FOUND
find_package( FFTW )

if( (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_LESS 2.8) )
	message( STATUS "Cmake version 2.8 or greater needed to use GTest" )
else()
	# This will define GTEST_FOUND
	find_package( GTest )

	# Hack to get googletest v1.6 to work with vs2012
	if( MSVC11 )
		add_definitions( "/D_VARIADIC_MAX=10" )
	endif( )
endif()

# Enable building of the clACML client if both requested and all dependencies are found
if( BUILD_CLIENT AND Boost_FOUND )
	set( FFT_CLIENT ON )
else( )
	set( FFT_CLIENT OFF )
endif( )

# Enable building of the googletest unit test framework if requested and all dependencies are found
if( BUILD_TEST AND GTEST_FOUND AND Boost_FOUND AND FFTW_FOUND )
	set( UNIT_TEST ON )
else( )
	message( "GoogleTest unit testing will NOT be built" )
	set( UNIT_TEST OFF )
endif( )

# FFLAGS depend on the compiler, grab the compiler name from the path
get_filename_component( C_COMPILER_NAME ${CMAKE_C_COMPILER} NAME_WE )
# message( "C_COMPILER_NAME: " ${C_COMPILER_NAME} )
# message( "CMAKE_C_COMPILER: " ${CMAKE_C_COMPILER} )

# Set common compile and link options
if( MSVC )
	# Following options for nMake
	message( STATUS "Detected MSVS Ver: " ${MSVC_VERSION} )

	# CMake sets huge stack frames for windows, for whatever reason.  We go with compiler default.
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}" )
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}" )
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}" )

elseif( CMAKE_COMPILER_IS_GNUCXX )
	message( STATUS "Detected GNU fortran compiler." )
	EXEC_PROGRAM( ${CMAKE_CXX_COMPILER} ARGS --version OUTPUT_VARIABLE vnum )
	STRING(REGEX REPLACE ".*([0-9])\\.([0-9])\\.([0-9]).*" "\\1\\2\\3" vnum ${vnum})
	if( ${vnum} STREQUAL "452" )
		# we only want c++0x if we're using gcc 4.5.2
		set( CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}" )
	endif()
	
	set( CMAKE_CXX_FLAGS "-pthread ${CMAKE_CXX_FLAGS}" )
	set( CMAKE_C_FLAGS "-pthread ${CMAKE_C_FLAGS}" )

	# For linux debug builds, define the same preprocessing symbols as win to keep it simple
	if( CMAKE_BUILD_TYPE MATCHES "Debug" )
		add_definitions( "/D_DEBUG" )
	endif( )

	if( BUILD64 )
		set( CMAKE_CXX_FLAGS "-m64 ${CMAKE_CXX_FLAGS}" )
		set( CMAKE_C_FLAGS "-m64 ${CMAKE_C_FLAGS}" )
	else( )
		set( CMAKE_CXX_FLAGS "-m32 ${CMAKE_CXX_FLAGS}" )
		set( CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}" )
	endif( )

    if( CODE_COVERAGE )
        set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
        set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage")
    endif()
endif( )

# If UNICODE is defined for microsoft compilers, pass extra definitions
if( MSVC AND UNICODE )
	add_definitions( "/DUNICODE /D_UNICODE" )
endif( )

# Print out compiler flags for viewing/debug
message( STATUS "CMAKE_CXX_COMPILER flags: " ${CMAKE_CXX_FLAGS} )
message( STATUS "CMAKE_CXX_COMPILER debug flags: " ${CMAKE_CXX_FLAGS_DEBUG} )
message( STATUS "CMAKE_CXX_COMPILER release flags: " ${CMAKE_CXX_FLAGS_RELEASE} )
message( STATUS "CMAKE_CXX_COMPILER relwithdebinfo flags: " ${CMAKE_CXX_FLAGS_RELWITHDEBINFO} )
message( STATUS "CMAKE_EXE_LINKER link flags: " ${CMAKE_EXE_LINKER_FLAGS} )

# configure a header file to pass the CMake version settings to the source, and package the header files in the output archive
configure_file( "${PROJECT_SOURCE_DIR}/include/clFFT.version.h.in" "${PROJECT_BINARY_DIR}/include/clFFT.version.h" )
install( FILES
			"${PROJECT_BINARY_DIR}/include/clFFT.version.h"
			"include/clFFT.h"
			"include/clAmdFft.h"
			"include/clAmdFft.version.h"
		DESTINATION
			"./include" )


# Recurse into subdirectory and start building files there
if( BUILD_RUNTIME AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/library" )
	add_subdirectory( library )
else()
	message( "Runtime library will NOT be built" )
endif( )

if( IS_DIRECTORY "${PROJECT_SOURCE_DIR}/scripts/perf" )
	add_subdirectory( scripts/perf )
endif( )

# We only want to build the following if the user options are set
if( FFT_CLIENT AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/client" )
	add_subdirectory( client )
else( )
	message( "FFT clients will NOT be built" )
endif( )

# Recurse into subdirectory and start building files there
if( BUILD_LOADLIBRARIES AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/statTimer" )
	add_subdirectory( statTimer )
else()
	message( "LoadLibraries will NOT be built" )
endif( )

if( UNIT_TEST AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/tests" )
	# enable_testing( )
	add_subdirectory( tests )
else( )
	message( "GoogleTest unit tests will NOT be built" )
endif( )

# The following code is setting variables to control the behavior of CPack to generate our
if( WIN32 )
	set( CPACK_SOURCE_GENERATOR "ZIP" )
	set( CPACK_GENERATOR "ZIP" )
else( )
	set( CPACK_SOURCE_GENERATOR "TGZ" )
	set( CPACK_GENERATOR "TGZ" )
endif( )

if( BUILD64 )
	set( CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CLFFT_VERSION}-${CMAKE_HOST_SYSTEM_NAME}-x64")
else( )
	set( CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CLFFT_VERSION}-${CMAKE_HOST_SYSTEM_NAME}-x32")
endif( )

set( CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CLFFT_VERSION}-${CMAKE_HOST_SYSTEM_NAME}-Source")

set( CPACK_PACKAGE_VERSION_MAJOR ${CLFFT_VERSION_MAJOR} )
set( CPACK_PACKAGE_VERSION_MINOR ${CLFFT_VERSION_MINOR} )
set( CPACK_PACKAGE_VERSION_PATCH ${CLFFT_VERSION_PATCH} )
set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "OpenCL implementation of an FFT library")
set( CPACK_PACKAGE_VENDOR "Neutral")
set( CPACK_SOURCE_IGNORE_FILES "/\\\\.hg/;/\\\\.svn/;/\\\\.git/" )

# Define all variables that influence CPack before including CPack, such as install targets
include( CPack )

=== src/client/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


#  client
set( Client.Source	client.cpp 
                    openCL.misc.cpp 
                    stdafx.cpp )

set( Client.Headers client.h 
                    openCL.misc.h 
                    ../statTimer/statisticalTimer.extern.h
                    ../include/unicode.compatibility.h 
                    ../include/stdafx.h 
                    ../include/targetver.h 
                    ../include/clFFT.h )

set( Client.Files ${Client.Source} ${Client.Headers} )

set( DL_LIB "" )
if( WIN32 )
	add_definitions( "/D_CONSOLE" )
elseif( APPLE )
	set( CMAKE_CXX_FLAGS "-std=c++11 -stdlib=libc++ ${CMAKE_CXX_FLAGS}" )	
else( )
	# To use the dlopen() and dlclose() functions, we should link with libdl
	set( DL_LIB "-ldl" )
endif( )

# Include standard OpenCL headers
include_directories( ${Boost_INCLUDE_DIRS} ${OPENCL_INCLUDE_DIRS} ../../../common ${PROJECT_BINARY_DIR}/include ../include )

add_executable( Client ${Client.Files} )

target_link_libraries( Client clFFT ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} ${DL_LIB} )

set_target_properties( Client PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( Client PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

# CPack configuration; include the executable into the package
install( TARGETS Client
        RUNTIME DESTINATION bin${SUFFIX_BIN}
        LIBRARY DESTINATION lib${SUFFIX_LIB}
        ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
        )

=== src/library/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

# List the names of common files to compile across all platforms
set( clFFT.Source	transform.cpp 
								accessors.cpp 
								plan.cpp 
								repo.cpp 
								generator.stockham.cpp 
								generator.transpose.cpp 
								generator.copy.cpp
								lifetime.cpp 
								stdafx.cpp )

# Windows only uses dllmain
if( MSVC )
	set( clFFT.Source ${clFFT.Source} dllmain.cpp )
endif( )

set( clFFT.Headers	private.h 
					repo.h 
					plan.h 
					lock.h 
					mainpage.h  
					generator.h 
					generator.stockham.h 
					generator.transpose.h 
					../include/stdafx.h 
					../include/unicode.compatibility.h 
					../include/targetver.h 
					../include/clAmdFft.h 
					../include/clFFT.h )

set( clFFT.Files ${clFFT.Source} ${clFFT.Headers} )

# For a rainy day, add pre-compiled header support
#if( MSVC )
#	if (USE_MSVC_PCH)
	
#		set_source_files_properties(LungAnalysisPCH.cxx
#			PROPERTIES
#			COMPILE_FLAGS "/YcLungAnalysisPCH.h"
#			)
#		foreach( src_file ${UPMC_LA_SRCS} )
#			set_source_files_properties(
#				${src_file}
#				PROPERTIES
#				COMPILE_FLAGS "/YuLungAnalysisPCH.h"
#				)
#		endforeach( src_file ${UPMC_LA_SRCS} )
		
#		list(APPEND UPMC_LA_SRCS LungAnalysisPCH.cxx)
#		list(APPEND UPMC_LA_HDRS LungAnalysisPCH.h)

#	endif(USE_MSVC_PCH)
#endif (MSVC)
  
#	add_definitions( ${Boost_LIB_DIAGNOSTIC_DEFINITIONS} )
add_definitions( "/DCLFFT_EXPORTS" )

# Include standard OpenCL headers
include_directories( ${OPENCL_INCLUDE_DIRS} ${PROJECT_BINARY_DIR}/include ../include )

if(BUILD_SHARED_LIBRARY)
  add_library( clFFT SHARED ${clFFT.Files} )
else()
  add_library( clFFT STATIC ${clFFT.Files} )
endif()
target_link_libraries( clFFT ${OPENCL_LIBRARIES} )

set_target_properties( clFFT PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( clFFT PROPERTIES SOVERSION ${CLFFT_SOVERSION} )
set_target_properties( clFFT PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

if( CMAKE_COMPILER_IS_GNUCC )
    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/clFFT.pc.in
                    ${CMAKE_CURRENT_BINARY_DIR}/clFFT.pc @ONLY )

    install( FILES ${CMAKE_CURRENT_BINARY_DIR}/clFFT.pc
             DESTINATION lib${SUFFIX_LIB}/pkgconfig )
endif( )

# CPack configuration; include the executable into the package
install( TARGETS clFFT
        RUNTIME DESTINATION bin${SUFFIX_BIN}
        LIBRARY DESTINATION lib${SUFFIX_LIB}
        ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
        )
        
# For debug builds, include the debug runtimes into the package for testing on non-developer machines
set( CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_SKIP true )
set( CMAKE_INSTALL_DEBUG_LIBRARIES true )
set( CMAKE_INSTALL_DEBUG_LIBRARIES_ONLY true )

if( WIN32 )
    set( CLFFT_RUNTIME_DESTINATION bin${SUFFIX_BIN} )
else( )
    set( CLFFT_RUNTIME_DESTINATION lib${SUFFIX_LIB} )
endif( )

include( InstallRequiredSystemLibraries )

# Install necessary runtime files for debug builds
install(    PROGRAMS ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS}
            CONFIGURATIONS Debug
            DESTINATION ${CLFFT_RUNTIME_DESTINATION} )

# Install all *.pdb files for debug builds
install(    DIRECTORY ${PROJECT_BINARY_DIR}/staging/
            DESTINATION ${CLFFT_RUNTIME_DESTINATION}
            OPTIONAL
            CONFIGURATIONS Debug
            FILES_MATCHING PATTERN "*.pdb" )

# Install a snapshot of the source as it was for this build; useful for the .pdb's
install(    DIRECTORY ${PROJECT_SOURCE_DIR}
            DESTINATION ${CLFFT_RUNTIME_DESTINATION}
            OPTIONAL
            CONFIGURATIONS Debug )

=== src/statTimer/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


# List the names of the files to compile for the external client . . .
set( StatTimer.Source 	statisticalTimer.CPU.cpp
								statisticalTimer.GPU.cpp
								statisticalTimer.extern.cpp
								stdafx.cpp )

# Windows only uses dllmain
if( MSVC )
	set( StatTimer.Source ${StatTimer.Source} dllmain.cpp )
endif( )

set( StatTimer.Headers	statisticalTimer.h
								statisticalTimer.extern.h
								statisticalTimer.CPU.h
								statisticalTimer.GPU.h
								stdafx.h 
								targetver.h 
								../include/clFFT.h )
								
set( StatTimer.Files ${StatTimer.Source} ${StatTimer.Headers} )

# For a rainy day, add pre-compiled header support
#if( MSVC )
#	if (USE_MSVC_PCH)
	
#		set_source_files_properties(LungAnalysisPCH.cxx
#			PROPERTIES
#			COMPILE_FLAGS "/YcLungAnalysisPCH.h"
#			)
#		foreach( src_file ${UPMC_LA_SRCS} )
#			set_source_files_properties(
#				${src_file}
#				PROPERTIES
#				COMPILE_FLAGS "/YuLungAnalysisPCH.h"
#				)
#		endforeach( src_file ${UPMC_LA_SRCS} )
		
#		list(APPEND UPMC_LA_SRCS LungAnalysisPCH.cxx)
#		list(APPEND UPMC_LA_HDRS LungAnalysisPCH.h)

#	endif(USE_MSVC_PCH)
#endif (MSVC)

add_definitions( "/DSTATTIMER_EXPORTS" )

# Include standard OpenCL headers
include_directories( ${OPENCL_INCLUDE_DIRS} ${PROJECT_BINARY_DIR}/include ../include )

if(BUILD_SHARED_LIBRARY)
  add_library( StatTimer SHARED ${StatTimer.Files} )
else()
  add_library( StatTimer STATIC ${StatTimer.Files} )
endif()
set_target_properties( StatTimer PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( StatTimer PROPERTIES SOVERSION ${CLFFT_SOVERSION} )
set_target_properties( StatTimer PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
target_link_libraries( StatTimer ${OPENCL_LIBRARIES} )

if( UNIX AND NOT APPLE )
	# This library dependency is brought in by the high precision timer available in linux
	target_link_libraries( StatTimer -lrt )
endif( )

# CPack configuration; include the executable into the package
install( TARGETS StatTimer
        RUNTIME DESTINATION bin${SUFFIX_BIN}
        LIBRARY DESTINATION lib${SUFFIX_LIB}
        ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
        )

=== src/tests/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


# List the names of the files to compile
set( clFFT.Test.Source
	 test_constants.cpp
	 buffer_memory.cpp
	 buffer.cpp
	 unit_test.cpp
	 accuracy_test_common.cpp
	 accuracy_test_pow2.cpp
	 accuracy_test_pow3.cpp
	 accuracy_test_pow5.cpp
	 accuracy_test_mixed_radices.cpp
	 accuracy_test_random.cpp
	 gtest_main.cpp
	 ${PROJECT_SOURCE_DIR}/client/openCL.misc.cpp
	 c-compliance.c
   )
   
set( clFFT.Test.Headers
	${PROJECT_SOURCE_DIR}/include/clFFT.h
	${PROJECT_SOURCE_DIR}/include/unicode.compatibility.h
	${PROJECT_SOURCE_DIR}/include/convenienceFunctions.h
	${PROJECT_SOURCE_DIR}/library/private.h
	${PROJECT_SOURCE_DIR}/client/openCL.misc.h
	accuracy_test_common.h
	test_constants.h
	buffer_memory.h
	buffer.h
	cl_transform.h
	fftw_transform.h
	typedefs.h
  )
  
set( clFFT.Test.Files ${clFFT.Test.Source} ${clFFT.Test.Headers} )

set( LD_PTHREAD "" )
if( MINGW )
    # -std=c++0x causes g++ to go into strict ANSI mode, which doesn't declare non-standard functions
    # Googletest for mingw appears to have a dependency on _stricmp and off64_t
	set( CMAKE_CXX_FLAGS "-std=gnu++0x ${CMAKE_CXX_FLAGS}" )
elseif( CMAKE_COMPILER_IS_GNUCXX )
	set( CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}" )
	set( LD_PTHREAD "-lpthread" )
elseif( APPLE )
	set( CMAKE_CXX_FLAGS "-std=c++11 -stdlib=libc++ ${CMAKE_CXX_FLAGS}" )
	add_definitions( -DGTEST_USE_OWN_TR1_TUPLE )
endif( )

# Include standard OpenCL headers
include_directories( ${Boost_INCLUDE_DIRS} ${GTEST_INCLUDE_DIRS} ${FFTW_INCLUDE_DIRS} ${OPENCL_INCLUDE_DIRS}  ${PROJECT_BINARY_DIR}/include ${PROJECT_SOURCE_DIR}/include )

add_executable( Test ${clFFT.Test.Files} )

# If the runtime is being built by the project, use it, otherwise link to a runtime library specified in the install prefix
if( BUILD_RUNTIME )
	target_link_libraries( Test clFFT ${Boost_LIBRARIES} ${GTEST_LIBRARIES} ${FFTW_LIBRARIES} ${OPENCL_LIBRARIES} ${LD_PTHREAD} )
else( )
	# Search for 64bit libs if FIND_LIBRARY_USE_LIB64_PATHS is set to true in the global environment, 32bit libs else
	get_property( LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS )
	if( LIB64 )
		set( clFFT.library "${CMAKE_INSTALL_PREFIX}/lib64" )
	else( )
		set( clFFT.library "${CMAKE_INSTALL_PREFIX}/lib32" )
	endif( )
	
	if( WIN32 )
		set( clFFT.library "${clFFT.library}/import/clFFT${CMAKE_STATIC_LIBRARY_SUFFIX}" )
	else( )
		set( clFFT.library "${clFFT.library}/${CMAKE_SHARED_LIBRARY_PREFIX}clFFT${CMAKE_SHARED_LIBRARY_SUFFIX}" )
	endif( )

	target_link_libraries( Test ${clFFT.library} ${Boost_LIBRARIES} ${GTEST_LIBRARIES} ${FFTW_LIBRARIES} ${OPENCL_LIBRARIES} ${LD_PTHREAD} )

endif( )

# The following set_target_properties is to get around a bug in cmake 2.8.2, where the suffix after the first '.' is dropped
IF( (MSVC_VERSION VERSION_EQUAL 1600) AND (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} VERSION_LESS 2.8.3) )
	message( STATUS "Detected vs2010 and Cmake version less than 2.8.3; renaming Test with underscores " )
	set_target_properties( Test PROPERTIES OUTPUT_NAME "clFFT_Test" )
ENDIF( )

set_target_properties( Test PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( Test PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

# CPack configuration; include the executable into the package
install( TARGETS Test
        RUNTIME DESTINATION bin${SUFFIX_BIN}
        LIBRARY DESTINATION lib${SUFFIX_LIB}
        ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
        )

get_target_property( testLocation Test LOCATION )

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/copyTestDependencies.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/copyTestDependencies.cmake"
    @ONLY
)

# Register script at run at install time to analyze the executable and copy dependencies into package
install( SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/copyTestDependencies.cmake")

=== src/scripts/perf/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(GRAPHING_SCRIPTS 	measurePerformance.py 
						plotPerformance.py 
						fftPerformanceTesting.py 
						errorHandler.py 
						performanceUtility.py
						)

install( FILES ${GRAPHING_SCRIPTS} DESTINATION bin${SUFFIX_BIN} )

=== debian/changelog ===
clfft (2.4-3) unstable; urgency=medium

  * Fix missing linkage with libdl in shlib package.
  * d/rules: set RelWithDebInfo as cmake build type.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 10 Jul 2015 08:14:08 +0100

clfft (2.4-2) unstable; urgency=medium

  * Make package build reproducible.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 09 Jul 2015 12:42:16 +0100

clfft (2.4-1) unstable; urgency=low

  * Initial release (Closes: # 783084) 

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 05 Jun 2015 14:47:10 +0100

=== debian/control ===
Source: clfft
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>,
           Jerome Kieffer <jerome.kieffer@esrf.fr>
Build-Depends: cmake,
               debhelper (>= 9),
               doxygen,
               libboost-program-options-dev,
               ocl-icd-opencl-dev
Standards-Version: 3.9.6
Homepage: https://github.com/clMathLibraries/clFFT
Vcs-Git: git://anonscm.debian.org/debian-science/packages/clfft.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clfft.git

Package: libclfft-bin
Section: libs
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libclfft2 (= ${binary:Version})
Description: OpenCL FFT library (executables)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT executables.

Package: libclfft-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libclfft2 (= ${binary:Version})
Suggests: libclfft-doc
Description: OpenCL FFT library (development files)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT development files.

Package: libclfft-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-mathjax
Description: OpenCL FFT library (documentation)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT documentation.

Package: libclfft2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL FFT library (shared library)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT shared library.

Package: libclfft2-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libclfft2 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL FFT library (debugging symbols)
 The clFFT library is an open source OpenCL library implementation of discrete 
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater 
     than 1.
   * Supports planar (real and complex components in separate arrays) and 
     interleaved (real and complex components as a pair contiguous in memory) 
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the clFFT debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --sourcedirectory=src \
		--buildsystem=cmake \
		--parallel \
		--dbg-package=libclfft2-dbg

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_RUNTIME=ON \
		-DBUILD_CLIENT=ON \
		-DBUILD_TEST=ON \
		-DBUILD_LOADLIBRARIES=OFF \
		-DBUILD_SHARED_LIBRARY=ON

override_dh_auto_build:
	dh_auto_build
	echo "I: Generating Doxygen documentation"
	cd doc/ && doxygen clFFT.doxy && rm html/jquery.js

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -f doc/doxygen_sqlite3.db
	$(RM) -rf doc/html

## clfft 2.6

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 endif( )
 
 if( NOT DEFINED CLFFT_VERSION_MINOR )
-    set( CLFFT_VERSION_MINOR 4 )
+    set( CLFFT_VERSION_MINOR 6 )
 endif( )
 
 if( NOT DEFINED CLFFT_VERSION_PATCH )
@@ -56,7 +56,7 @@
 
 # On windows, it's convenient to change the default install prefix such that it does NOT point to 'program files'
 # Need to check out CMAKE_RUNTIME_OUTPUT_DIRECTORY variable, and see if that eliminates the need to modify install path
-if( CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
+if( WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
 	set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories" FORCE )
 endif( )
 
@@ -70,7 +70,8 @@
 option( BUILD_CLIENT "Build a command line clFFT client program with a variety of configurable parameters (dependency on Boost)" ON )
 option( BUILD_TEST "Build the library testing suite (dependency on google test, Boost, and FFTW)" ON )
 option( BUILD_LOADLIBRARIES "Build the optional dynamic load libraries that the FFT runtime will search for" ON )
-option( BUILD_SHARED_LIBRARY "Build shared libraries." ON)
+option( BUILD_SHARED_LIBS "Build shared libraries." ON)
+option( BUILD_EXAMPLES "Build examples." ON)
 
 # If BOOST_ROOT is defined as an environment value, use that value and cache it so it's visible in the cmake-gui.
 # Otherwise, create a sensible default that the user can change
@@ -115,8 +116,9 @@
 if( BUILD64 )
 	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE )
 	message( STATUS "64bit build - FIND_LIBRARY_USE_LIB64_PATHS TRUE" )
-
-    set( SUFFIX_LIB_DEFAULT "64" )
+    if( NOT APPLE )
+      set( SUFFIX_LIB_DEFAULT "64" )
+    endif()
 else( )
 	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE )
 	message( STATUS "32bit build - FIND_LIBRARY_USE_LIB64_PATHS FALSE" )
@@ -155,18 +157,6 @@
 # This will define FFTW_FOUND
 find_package( FFTW )
 
-if( (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_LESS 2.8) )
-	message( STATUS "Cmake version 2.8 or greater needed to use GTest" )
-else()
-	# This will define GTEST_FOUND
-	find_package( GTest )
-
-	# Hack to get googletest v1.6 to work with vs2012
-	if( MSVC11 )
-		add_definitions( "/D_VARIADIC_MAX=10" )
-	endif( )
-endif()
-
 # Enable building of the clACML client if both requested and all dependencies are found
 if( BUILD_CLIENT AND Boost_FOUND )
 	set( FFT_CLIENT ON )
@@ -175,17 +165,25 @@
 endif( )
 
 # Enable building of the googletest unit test framework if requested and all dependencies are found
-if( BUILD_TEST AND GTEST_FOUND AND Boost_FOUND AND FFTW_FOUND )
-	set( UNIT_TEST ON )
-else( )
-	message( "GoogleTest unit testing will NOT be built" )
-	set( UNIT_TEST OFF )
+set( UNIT_TEST OFF )
+if( BUILD_TEST )
+    include(gtest.cmake)
+    if( GTEST_FOUND AND Boost_FOUND AND FFTW_FOUND )
+		set( UNIT_TEST ON )
+	else( )
+		message( "GoogleTest unit testing will NOT be built" )
+    endif( )
 endif( )
 
 # FFLAGS depend on the compiler, grab the compiler name from the path
 get_filename_component( C_COMPILER_NAME ${CMAKE_C_COMPILER} NAME_WE )
 # message( "C_COMPILER_NAME: " ${C_COMPILER_NAME} )
 # message( "CMAKE_C_COMPILER: " ${CMAKE_C_COMPILER} )
+
+if(APPLE)
+    # avoid warning on newer cmake versions
+    set(CMAKE_MACOSX_RPATH 0)
+endif()
 
 # Set common compile and link options
 if( MSVC )
@@ -240,6 +238,9 @@
 message( STATUS "CMAKE_CXX_COMPILER relwithdebinfo flags: " ${CMAKE_CXX_FLAGS_RELWITHDEBINFO} )
 message( STATUS "CMAKE_EXE_LINKER link flags: " ${CMAKE_EXE_LINKER_FLAGS} )
 
+if(NOT BUILD_SHARED_LIBS)
+  set(CLFFT_STATIC ON)
+endif()
 # configure a header file to pass the CMake version settings to the source, and package the header files in the output archive
 configure_file( "${PROJECT_SOURCE_DIR}/include/clFFT.version.h.in" "${PROJECT_BINARY_DIR}/include/clFFT.version.h" )
 install( FILES
@@ -250,7 +251,6 @@
 		DESTINATION
 			"./include" )
 
-
 # Recurse into subdirectory and start building files there
 if( BUILD_RUNTIME AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/library" )
 	add_subdirectory( library )
@@ -282,6 +282,29 @@
 else( )
 	message( "GoogleTest unit tests will NOT be built" )
 endif( )
+
+if( BUILD_EXAMPLES )
+    add_subdirectory( examples )
+endif()
+
+if(WIN32)
+  set(destdir CMake)
+else()
+  set(destdir share/clFFT)
+endif()
+string(REGEX REPLACE "[^/]+" ".." reldir "${destdir}")
+configure_file(
+  ${CMAKE_CURRENT_SOURCE_DIR}/clFFTConfigVersion.cmake.in
+  ${CMAKE_CURRENT_BINARY_DIR}/clFFTConfigVersion.cmake
+  @ONLY)
+configure_file(
+  ${CMAKE_CURRENT_SOURCE_DIR}/clFFTConfig.cmake.in
+  ${CMAKE_CURRENT_BINARY_DIR}/clFFTConfig.cmake
+  @ONLY)
+install(EXPORT Library DESTINATION ${destdir} FILE clFFTTargets.cmake)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/clFFTConfigVersion.cmake
+  ${CMAKE_CURRENT_BINARY_DIR}/clFFTConfig.cmake
+  DESTINATION ${destdir})
 
 # The following code is setting variables to control the behavior of CPack to generate our
 if( WIN32 )
@@ -298,14 +321,3 @@
 	set( CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CLFFT_VERSION}-${CMAKE_HOST_SYSTEM_NAME}-x32")
 endif( )
 
-set( CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CLFFT_VERSION}-${CMAKE_HOST_SYSTEM_NAME}-Source")
-
-set( CPACK_PACKAGE_VERSION_MAJOR ${CLFFT_VERSION_MAJOR} )
-set( CPACK_PACKAGE_VERSION_MINOR ${CLFFT_VERSION_MINOR} )
-set( CPACK_PACKAGE_VERSION_PATCH ${CLFFT_VERSION_PATCH} )
-set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "OpenCL implementation of an FFT library")
-set( CPACK_PACKAGE_VENDOR "Neutral")
-set( CPACK_SOURCE_IGNORE_FILES "/\\\\.hg/;/\\\\.svn/;/\\\\.git/" )
-
-# Define all variables that influence CPack before including CPack, such as install targets
-include( CPack )

=== src/client/CMakeLists.txt ===
--- 
+++ 
@@ -30,28 +30,30 @@
 
 set( Client.Files ${Client.Source} ${Client.Headers} )
 
-set( DL_LIB "" )
+set( RT_LIB "" )
 if( WIN32 )
 	add_definitions( "/D_CONSOLE" )
-elseif( APPLE )
-	set( CMAKE_CXX_FLAGS "-std=c++11 -stdlib=libc++ ${CMAKE_CXX_FLAGS}" )	
-else( )
+elseif( NOT APPLE )
 	# To use the dlopen() and dlclose() functions, we should link with libdl
-	set( DL_LIB "-ldl" )
+	set( RT_LIB "-lrt" )
 endif( )
 
 # Include standard OpenCL headers
 include_directories( ${Boost_INCLUDE_DIRS} ${OPENCL_INCLUDE_DIRS} ../../../common ${PROJECT_BINARY_DIR}/include ../include )
 
-add_executable( Client ${Client.Files} )
+add_executable( clFFT-client ${Client.Files} )
 
-target_link_libraries( Client clFFT ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} ${DL_LIB} )
+target_link_libraries( clFFT-client clFFT ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} ${CMAKE_DL_LIBS} ${RT_LIB} )
 
-set_target_properties( Client PROPERTIES VERSION ${CLFFT_VERSION} )
-set_target_properties( Client PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
+set_target_properties( clFFT-client PROPERTIES VERSION ${CLFFT_VERSION} )
+set_target_properties( clFFT-client PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
+if( APPLE )
+    # properly deal with RPATH on mac
+    set_target_properties( clFFT-client PROPERTIES INSTALL_RPATH "@loader_path/../lib${SUFFIX_LIB}")
+endif()
 
 # CPack configuration; include the executable into the package
-install( TARGETS Client
+install( TARGETS clFFT-client
         RUNTIME DESTINATION bin${SUFFIX_BIN}
         LIBRARY DESTINATION lib${SUFFIX_LIB}
         ARCHIVE DESTINATION lib${SUFFIX_LIB}/import

=== src/examples/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

INCLUDE_DIRECTORIES(
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${OPENCL_INCLUDE_DIRS}"
    "${PROJECT_SOURCE_DIR}/include"
    "${PROJECT_BINARY_DIR}/include"
    )

LINK_DIRECTORIES("${PROJECT_BINARY_DIR}/package/lib${SUFFIX_LIB}")

FILE(GLOB FILES "*.c")

FOREACH(FILE ${FILES})

    if( MSVC )
    	if( MSVC_VERSION LESS 1800 )
    		# Use C++ with Microsoft compiler
    		SET_SOURCE_FILES_PROPERTIES( ${FILE} PROPERTIES LANGUAGE CXX)
    	endif ()
    endif( )

    GET_FILENAME_COMPONENT(EXAMPLE ${FILE} NAME_WE)
    GET_FILENAME_COMPONENT(FULL_DIR_NAME ${FILE} PATH)
    GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)
    SET(EXAMPLE_NAME example_${DIR_NAME}_${EXAMPLE})
    ADD_EXECUTABLE(${EXAMPLE_NAME} ${FILE})

    TARGET_LINK_LIBRARIES(${EXAMPLE_NAME} clFFT ${OPENCL_LIBRARIES} ${CMAKE_DL_LIBS})

    SET_TARGET_PROPERTIES(${EXAMPLE_NAME}
        PROPERTIES
        OUTPUT_NAME ${EXAMPLE}
        RUNTIME_OUTPUT_DIRECTORY ${DIR_NAME})

    INSTALL(TARGETS ${EXAMPLE_NAME}
        RUNTIME DESTINATION "bin${SUFFIX_BIN}/examples")
ENDFOREACH()

=== src/library/CMakeLists.txt ===
--- 
+++ 
@@ -20,9 +20,13 @@
 								plan.cpp 
 								repo.cpp 
 								generator.stockham.cpp 
-								generator.transpose.cpp 
+								generator.transpose.vliw.cpp 
+								generator.transpose.gcn.cpp 
 								generator.copy.cpp
 								lifetime.cpp 
+								fft_binary_lookup.cpp
+								md5sum.c
+								action.cpp
 								stdafx.cpp )
 
 # Windows only uses dllmain
@@ -31,13 +35,17 @@
 endif( )
 
 set( clFFT.Headers	private.h 
+					action.h
 					repo.h 
 					plan.h 
 					lock.h 
 					mainpage.h  
 					generator.h 
 					generator.stockham.h 
-					generator.transpose.h 
+					generator.transpose.vliw.h 
+					generator.transpose.gcn.h 
+					fft_binary_lookup.h
+					md5sum.h
 					../include/stdafx.h 
 					../include/unicode.compatibility.h 
 					../include/targetver.h 
@@ -74,11 +82,7 @@
 # Include standard OpenCL headers
 include_directories( ${OPENCL_INCLUDE_DIRS} ${PROJECT_BINARY_DIR}/include ../include )
 
-if(BUILD_SHARED_LIBRARY)
-  add_library( clFFT SHARED ${clFFT.Files} )
-else()
-  add_library( clFFT STATIC ${clFFT.Files} )
-endif()
+add_library( clFFT ${clFFT.Files} )
 target_link_libraries( clFFT ${OPENCL_LIBRARIES} )
 
 set_target_properties( clFFT PROPERTIES VERSION ${CLFFT_VERSION} )
@@ -95,6 +99,7 @@
 
 # CPack configuration; include the executable into the package
 install( TARGETS clFFT
+        EXPORT Library
         RUNTIME DESTINATION bin${SUFFIX_BIN}
         LIBRARY DESTINATION lib${SUFFIX_LIB}
         ARCHIVE DESTINATION lib${SUFFIX_LIB}/import

=== src/scripts/perf/CMakeLists.txt ===
--- 
+++ 
@@ -20,5 +20,8 @@
 						errorHandler.py 
 						performanceUtility.py
 						)
-
-install( FILES ${GRAPHING_SCRIPTS} DESTINATION bin${SUFFIX_BIN} )
+if( WIN32 )
+	install( FILES ${GRAPHING_SCRIPTS} DESTINATION bin${SUFFIX_BIN} )
+else ( )
+	install( FILES ${GRAPHING_SCRIPTS} DESTINATION share/clFFT )
+endif( )

=== debian/changelog ===
clfft (2.6-1) unstable; urgency=medium

  * New upstream release.
  * Break fix-doxygen-settings.patch down to more specific patches:
    - fix-docs-output.patch,
    - use-system-mathjax.patch,
    - reproducible-build.patch.
  * Drop the following patches:
    - fix-client-name.patch,
    - fix-cmake-config-install.patch.
    Reason: applied upstream.
  * Improve fix-libdl-linkage.patch.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 30 Jul 2015 19:09:24 +0100

clfft (2.4-4) unstable; urgency=medium

  * Add gbp.conf file.
  * Allow build with alternative OpenCL implementation.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 30 Jul 2015 11:56:53 +0100
